/** If the numbers 1 to 5 are written out in words: one, two, three, four, five, then there are 3 + 3 + 5 + 4 + 4 = 19 letters used in total.
If all the numbers from 1 to 1000 (one thousand) inclusive were written out in words, how many letters would be used?
NOTE: Do not count spaces or hyphens. For example, 342 (three hundred and forty-two) contains 23 letters and 115 (one hundred and fifteen) contains 20 letters. The use of "and" when writing out numbers is in compliance with British usage. */

#include "0.hpp"

int ele[20] = {0, 3, 3, 5, 4, 4, 3, 5, 5, 4, 3,
6, 6, 8, 8, 7, 7, 9, 8, 8};

int ten[11] = {0, 3, 6, 6, 5, 5, 5, 7, 6, 6, 7};

int dot[4] = {0, 8, 7, 7};

string eles[20] = {"", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "ten", "eleven", "twelve", "thirteen", "fourteen", "fifteen", "sixteen", "seventeen", "eighteen", "nineteen"};

string tens[11] = {"", "ten", "twenty", "thirty", "forty", "fifty", "sixty", "seventy", "eighty", "nithty", "hundrad"};

string dots[4] = {"", "thousand", "million", "billion"};

int analyse(int x)
{
  int a = x / 100;
  int b = x % 100;
  int out = 0;
  if(a) {
    if(a / 10) {
      out += ele[a / 10] + dot[1]; // thousand
      cout << eles[a / 10] + " " + dots[1] + " ";
    }
    if(a % 10) {
      out += ele[a % 10] + ten[10]; // hundrad
      cout << eles[a % 10] + " " + tens[10] + " ";
    }
    if(b) {
      out += 3; // and
      cout << "and ";
    }
  }
  if(b >= 20) {
      out += ele[b % 10] + ten[b / 10];
    cout << tens[b / 10] + " " + eles[b % 10] + " ";
  }
  else {
    out += ele[b];
    cout << eles[b];
  }
  cout << endl;
  return out;
}

int main()
{
  int sum = 0;
  for(int i = 1; i <= 1000; i++) sum += analyse(i);
  cout << sum << endl;
  return 0;
}
