/** A unit fraction contains 1 in the numerator. The decimal representation of the unit fractions with denominators 2 to 10 are given:
1/2 =  0.5
1/3 =  0.(3)
1/4 =  0.25
1/5 =  0.2
1/6 =  0.1(6)
1/7 =  0.(142857)
1/8 =  0.125
1/9 =  0.(1)
1/10 =  0.1
Where 0.1(6) means 0.166666..., and has a 1-digit recurring cycle. It can be seen that 1/7 has a 6-digit recurring cycle.
Find the value of d < 1000 for which 1/d contains the longest recurring cycle in its decimal fraction part. */

#include "0.hpp"

const int _max = 10000;

int cycle(int num)
{
  int mod[_max] = {0};
  int temp = 10;
  int count = 0;
  int flag = 1;
  do {
    if(temp == 0) break;
    if(temp < num) temp *= 10;
    //cout << temp / num;
    temp %= num;
    mod[count] = temp;
    for(int i = 0; i <= count - 1; i++)
      if(temp == mod[i]) {
        flag = 0;
        count -= i;
        count--;
      }
    count++;
  } while(flag);
  //cout << '\t' << count << endl;
  return count;
}

int main()
{
  int max[2] = {0, 0};
  for(int i = 2; i <= _max; i++) {
    //cout << i << '\t';
    int temp = cycle(i);
    if(temp > max[1]) {
      max[0] = i;
      max[1] = temp;
    }
  }
  
  cout << max[0] << '\t' << max[1] << endl;
  return 0;
}
